osl::eval::ml::King8EffectBase Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Protected Member Functions | List of all members
osl::eval::ml::King8EffectBase Class Reference

`#include <king8.h>`

Inheritance diagram for osl::eval::ml::King8EffectBase:
[legend]

## Classes
struct | MakeEffectStateDefense
struct | MakeEffectStateSimple

## Public Types
enum | { DIM = 32 }
enum | EffectState { NOT_EMPTY = -1, NO_EFFECT = 0, LESS_EFFECT, MORE_EFFECT, MORE_EFFECT_KING_ONLY }
typedef CArray< int, 32 > | table_t

## Public Member Functions
template<class MakeEffectState >
const osl::CArray< int, 2 > | evalCommon (const osl::state::NumEffectState &state, const table_t &table)
template<class MakeEffectState >
const osl::CArray< int, 2 > | evalWithUpdateCommon (const osl::state::NumEffectState &new_state, Move last_move, const CArray< int, 2 > &last_value, const table_t &table)
template<class MakeEffectState >
std::pair< osl::CArray< int, 2 > , osl::CArray< int, 2 > > | evalWithUpdateCommon (const osl::state::NumEffectState &new_state, Move last_move, const CArray< int, 2 > &last_value_o, const CArray< int, 2 > &last_value_e, const table_t &table_o, const table_t &table_e)

## Static Public Member Functions
template<class MakeEffectState >
static const CArray< int, 2 > | evalCommon (const osl::state::NumEffectState &state, const table_t &)
template<class MakeEffectState >
static const CArray< int, 2 > | evalWithUpdateCommon (const osl::state::NumEffectState &new_state, Move last_move, const CArray< int, 2 > &last_value, const table_t &)
template<class MakeEffectState >
static std::pair< CArray< int, 2 > , CArray< int, 2 > > | evalWithUpdateCommon (const NumEffectState &new_state, Move last_move, const CArray< int, 2 > &last_value_opening, const CArray< int, 2 > &last_value_ending, const table_t &, const table_t &)

## Static Protected Member Functions
static int | index (const Direction dir, EffectState state)

## Detailed Description

Definition at line 52 of file eval/ml/king8.h.

## Member Typedef Documentation

typedef CArray<int, 32> osl::eval::ml::King8EffectBase::table_t

Definition at line 56 of file eval/ml/king8.h.

## Member Enumeration Documentation

anonymous enum

Enumerator
DIM |

Definition at line 55 of file eval/ml/king8.h.

enum osl::eval::ml::King8EffectBase::EffectState

Enumerator
NOT_EMPTY |
NO_EFFECT |
LESS_EFFECT |
MORE_EFFECT |
MORE_EFFECT_KING_ONLY |

Definition at line 57 of file eval/ml/king8.h.

## Member Function Documentation

template<class MakeEffectState >

static const CArray<int,2> osl::eval::ml::King8EffectBase::evalCommon | ( | const osl::state::NumEffectState & | state,
|  | const table_t & |
| ) |  |
| static

template<class MakeEffectState >

const osl::CArray<int,2> osl::eval::ml::King8EffectBase::evalCommon | ( | const osl::state::NumEffectState & | state,
|  | const table_t & | table
| ) |  |

Definition at line 212 of file eval/ml/king8.cc.

References osl::BLACK, result, osl::SHORT8_DIRECTION_MAX, osl::SHORT8_DIRECTION_MIN, and osl::WHITE.

template<class MakeEffectState >

static const CArray<int,2> osl::eval::ml::King8EffectBase::evalWithUpdateCommon | ( | const osl::state::NumEffectState & | new_state,
|  | Move | last_move,
|  | const CArray< int, 2 > & | last_value,
|  | const table_t & |
| ) |  |
| static

template<class MakeEffectState >

static std::pair<CArray<int,2>, CArray<int,2> > osl::eval::ml::King8EffectBase::evalWithUpdateCommon | ( | const NumEffectState & | new_state,
|  | Move | last_move,
|  | const CArray< int, 2 > & | last_value_opening,
|  | const CArray< int, 2 > & | last_value_ending,
|  | const table_t & | ,
|  | const table_t & |
| ) |  |
| static

template<class MakeEffectState >

const osl::CArray<int,2> osl::eval::ml::King8EffectBase::evalWithUpdateCommon | ( | const osl::state::NumEffectState & | new_state,
|  | Move | last_move,
|  | const CArray< int, 2 > & | last_value,
|  | const table_t & | table
| ) |  |

Definition at line 240 of file eval/ml/king8.cc.

References osl::container::Board_Mask_Table3x3, osl::state::NumEffectState::changedEffects(), osl::Move::from(), osl::indexToPlayer(), osl::state::SimpleState::kingSquare(), osl::container::BoardMaskTable3x3::mask(), result, osl::SHORT8_DIRECTION_MAX, osl::SHORT8_DIRECTION_MIN, osl::Move::to(), and update().

template<class MakeEffectState >

std::pair<osl::CArray<int,2>, osl::CArray<int,2> > osl::eval::ml::King8EffectBase::evalWithUpdateCommon | ( | const osl::state::NumEffectState & | new_state,
|  | Move | last_move,
|  | const CArray< int, 2 > & | last_value_o,
|  | const CArray< int, 2 > & | last_value_e,
|  | const table_t & | table_o,
|  | const table_t & | table_e
| ) |  |
| inline

Definition at line 273 of file eval/ml/king8.cc.

References osl::container::Board_Mask_Table3x3, osl::state::NumEffectState::changedEffects(), osl::Move::from(), osl::indexToPlayer(), osl::state::SimpleState::kingSquare(), osl::container::BoardMaskTable3x3::mask(), osl::SHORT8_DIRECTION_MAX, osl::SHORT8_DIRECTION_MIN, osl::Move::to(), and update().

static int osl::eval::ml::King8EffectBase::index | ( | const Direction | dir,
|  | EffectState | state
| ) |  |
| inlinestaticprotected

Definition at line 80 of file eval/ml/king8.h.

The documentation for this class was generated from the following files:

- eval/ml/king8.h
- eval/ml/king8.cc